config/routes.rb
Chefster::Application.routes.draw do
  resources :quantities

  resources :ingredients

  get "pages/index"
  get "pages/about"

  root :to => 'pages#index'
  match "about" => 'pages#about'
  match "contact" => 'pages#contact'

end

app/models/ingredient.rb
class Ingredient < ActiveRecord::Base
  attr_accessible :description, :name

  validates :name, :presence => true
end

app/models/quantity.rb
class Quantity < ActiveRecord::Base
  attr_accessible :name, :plural, :singular
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery
end

app/controllers/ingredients_controller.rb
class IngredientsController < ApplicationController
  # GET /ingredients
  # GET /ingredients.json
  def index
    @ingredients = Ingredient.all

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @ingredients }
    end
  end

  # GET /ingredients/1
  # GET /ingredients/1.json
  def show
    @ingredient = Ingredient.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @ingredient }
    end
  end

  # GET /ingredients/new
  # GET /ingredients/new.json
  def new
    @ingredient = Ingredient.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @ingredient }
    end
  end

  # GET /ingredients/1/edit
  def edit
    @ingredient = Ingredient.find(params[:id])
  end

  # POST /ingredients
  # POST /ingredients.json
  def create
    @ingredient = Ingredient.new(params[:ingredient])

    respond_to do |format|
      if @ingredient.save
        format.html { redirect_to @ingredient, notice: 'Ingredient was successfully created.' }
        format.json { render json: @ingredient, status: :created, location: @ingredient }
      else
        format.html { render action: "new" }
        format.json { render json: @ingredient.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /ingredients/1
  # PUT /ingredients/1.json
  def update
    @ingredient = Ingredient.find(params[:id])

    respond_to do |format|
      if @ingredient.update_attributes(params[:ingredient])
        format.html { redirect_to @ingredient, notice: 'Ingredient was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @ingredient.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /ingredients/1
  # DELETE /ingredients/1.json
  def destroy
    @ingredient = Ingredient.find(params[:id])
    @ingredient.destroy

    respond_to do |format|
      format.html { redirect_to ingredients_url }
      format.json { head :no_content }
    end
  end
end

app/controllers/pages_controller.rb
class PagesController < ApplicationController
  def index
  end

  def about
  end

  def contact
  end
end

app/controllers/quantities_controller.rb
class QuantitiesController < ApplicationController
  # GET /quantities
  # GET /quantities.json
  def index
    @quantities = Quantity.all

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @quantities }
    end
  end

  # GET /quantities/1
  # GET /quantities/1.json
  def show
    @quantity = Quantity.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @quantity }
    end
  end

  # GET /quantities/new
  # GET /quantities/new.json
  def new
    @quantity = Quantity.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @quantity }
    end
  end

  # GET /quantities/1/edit
  def edit
    @quantity = Quantity.find(params[:id])
  end

  # POST /quantities
  # POST /quantities.json
  def create
    @quantity = Quantity.new(params[:quantity])

    respond_to do |format|
      if @quantity.save
        format.html { redirect_to @quantity, notice: 'Quantity was successfully created.' }
        format.json { render json: @quantity, status: :created, location: @quantity }
      else
        format.html { render action: "new" }
        format.json { render json: @quantity.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /quantities/1
  # PUT /quantities/1.json
  def update
    @quantity = Quantity.find(params[:id])

    respond_to do |format|
      if @quantity.update_attributes(params[:quantity])
        format.html { redirect_to @quantity, notice: 'Quantity was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @quantity.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /quantities/1
  # DELETE /quantities/1.json
  def destroy
    @quantity = Quantity.find(params[:id])
    @quantity.destroy

    respond_to do |format|
      format.html { redirect_to quantities_url }
      format.json { head :no_content }
    end
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/ingredients_helper.rb
module IngredientsHelper
end

app/helpers/quantities_helper.rb
module QuantitiesHelper
end

app/views/ingredients/_form.html.erb
<%= form_for(@ingredient) do |f| %>
  <% if @ingredient.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@ingredient.errors.count, "error") %> prohibited this ingredient from being saved:</h2>

      <ul>
      <% @ingredient.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br />
    <%= f.text_field :name %>
  </div>
  <div class="field">
    <%= f.label :description %><br />
    <%= f.text_area :description %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/ingredients/edit.html.erb
<h1>Editing ingredient</h1>

<%= render 'form' %>

<%= link_to 'Show', @ingredient %> |
<%= link_to 'Back', ingredients_path %>

app/views/ingredients/index.html.erb
<h1>Listing ingredients</h1>

<table>
  <tr>
    <th>Name</th>
    <th>Description</th>
    <th></th>
    <th></th>
    <th></th>
  </tr>

<% @ingredients.each do |ingredient| %>
  <tr>
    <td><%= ingredient.name %></td>
    <td><%= ingredient.description %></td>
    <td><%= link_to 'Show', ingredient %></td>
    <td><%= link_to 'Edit', edit_ingredient_path(ingredient) %></td>
    <td><%= link_to 'Destroy', ingredient, method: :delete, data: { confirm: 'Are you sure?' } %></td>
  </tr>
<% end %>
</table>

<br />

<%= link_to 'New Ingredient', new_ingredient_path %>

app/views/ingredients/new.html.erb
<h1>New ingredient</h1>

<%= render 'form' %>

<%= link_to 'Back', ingredients_path %>

app/views/ingredients/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <b>Name:</b>
  <%= @ingredient.name %>
</p>

<p>
  <b>Description:</b>
  <%= @ingredient.description %>
</p>


<%= link_to 'Edit', edit_ingredient_path(@ingredient) %> |
<%= link_to 'Back', ingredients_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Chefster</title>
  <%= stylesheet_link_tag    "application", :media => "all" %>
  <%= stylesheet_link_tag "bootstrap", :media => "all" %>
  <%= stylesheet_link_tag "bootstrap_responsive", :media => "all" %>
  <%= javascript_include_tag "application" %>
  <%= javascript_include_tag "bootstrap" %>
  <%= csrf_meta_tags %>
</head>
<body>
  <div class="navbar navbar-inverse navbar-fixed-top">
    <div class="navbar-inner">
      <div class="container">
        <a class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </a>
        <a class="brand" href="/">Chefster</a>
        <div class="nav-collapse collapse">
          <ul class="nav">
            <li class="active"><a href="/">Home</a></li>
            <li><a href="about">About</a></li>
            <li><a href="contact">Contact</a></li>
          </ul>
        </div><!--/.nav-collapse -->
      </div>
    </div>
  </div>
  <div class="container">
    <%= yield %>
  </div>

</body>
</html>

app/views/pages/about.html.erb
<h1>About</h1>
<p>This is a little pet project of mine to help me with grocery lists and remember what I want to cook.</p>

app/views/pages/contact.html.erb
<h1>Contact</h1>
<p>This is the project of Yusuke Tsutsumi (yusuketsutsumi.com). You can contact me at yusuke@yusuketsutsumi.com</p>

app/views/pages/index.html.erb
<h1>Hello, Rails!</h1>
<%= link_to "My Ingredients", ingredients_path %>
<%= link_to "My Quantities", quantities_path %>
<p>Find me in app/views/home/index.html.erb</p>

app/views/quantities/_form.html.erb
<%= form_for(@quantity) do |f| %>
  <% if @quantity.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@quantity.errors.count, "error") %> prohibited this quantity from being saved:</h2>

      <ul>
      <% @quantity.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br />
    <%= f.text_field :name %>
  </div>
  <div class="field">
    <%= f.label :singular %><br />
    <%= f.text_field :singular %>
  </div>
  <div class="field">
    <%= f.label :plural %><br />
    <%= f.text_field :plural %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/quantities/edit.html.erb
<h1>Editing quantity</h1>

<%= render 'form' %>

<%= link_to 'Show', @quantity %> |
<%= link_to 'Back', quantities_path %>

app/views/quantities/index.html.erb
<h1>Listing quantities</h1>

<table>
  <tr>
    <th>Name</th>
    <th>Singular</th>
    <th>Plural</th>
    <th></th>
    <th></th>
    <th></th>
  </tr>

<% @quantities.each do |quantity| %>
  <tr>
    <td><%= quantity.name %></td>
    <td><%= quantity.singular %></td>
    <td><%= quantity.plural %></td>
    <td><%= link_to 'Show', quantity %></td>
    <td><%= link_to 'Edit', edit_quantity_path(quantity) %></td>
    <td><%= link_to 'Destroy', quantity, method: :delete, data: { confirm: 'Are you sure?' } %></td>
  </tr>
<% end %>
</table>

<br />

<%= link_to 'New Quantity', new_quantity_path %>

app/views/quantities/new.html.erb
<h1>New quantity</h1>

<%= render 'form' %>

<%= link_to 'Back', quantities_path %>

app/views/quantities/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <b>Name:</b>
  <%= @quantity.name %>
</p>

<p>
  <b>Singular:</b>
  <%= @quantity.singular %>
</p>

<p>
  <b>Plural:</b>
  <%= @quantity.plural %>
</p>


<%= link_to 'Edit', edit_quantity_path(@quantity) %> |
<%= link_to 'Back', quantities_path %>